tpm_selftest_tests.sh 2.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109
  1. #! /bin/sh
  2. #
  3. # Copyright (c) International Business Machines Corp., 2005
  4. #
  5. # This program is free software; you can redistribute it and#or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation; either version 2 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful, but
  11. # WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  12. # or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  13. # for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program; if not, write to the Free Software
  17. # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  18. #
  19. setup()
  20. {
  21. RC=0 # Return code from commands.
  22. if [ -z "$LTPTMP" ] && [ -z "$TMPBASE" ]
  23. then
  24. LTPTMP="/tmp"
  25. else
  26. LTPTMP="$TMPBASE"
  27. fi
  28. export TPM_TMPFILE="$LTPTMP/tst_tpm.err"
  29. rm -f $TPM_TMPFILE 2>&1
  30. tst_resm TINFO "INIT: Inititalizing tests."
  31. which tpm_selftest 1>$TPM_TMPFILE 2>&1 || RC=$?
  32. if [ $RC -ne 0 ]
  33. then
  34. tst_brk TBROK $TPM_TMPFILE NULL \
  35. "Setup: tpm_selftest command does not exist. Reason:"
  36. return $RC
  37. fi
  38. return $RC
  39. }
  40. test01()
  41. {
  42. RC=0 # Return value from commands
  43. export TCID=tpm_selftest01 # Test ID
  44. export TST_COUNT=1 # Test number
  45. tpm_selftest 1>$TPM_TMPFILE 2>&1 || RC=$?
  46. if [ $RC -eq 0 ]
  47. then
  48. tst_resm TPASS "'tpm_selftest' passed."
  49. RC=0
  50. else
  51. tst_res TFAIL $TPM_TMPFILE "'tpm_selftest' failed."
  52. RC=1
  53. fi
  54. return $RC
  55. }
  56. test02()
  57. {
  58. RC=0 # Return value from commands
  59. export TCID=tpm_selftest02 # Test ID
  60. export TST_COUNT=2 # Test number
  61. tpm_selftest -r 1>$TPM_TMPFILE 2>&1 || RC=$?
  62. if [ $RC -eq 0 ]
  63. then
  64. tst_resm TPASS "'tpm_selftest -r' passed."
  65. RC=0
  66. else
  67. tst_res TFAIL $TPM_TMPFILE "'tpm_selftest -r' failed."
  68. RC=1
  69. fi
  70. return $RC
  71. }
  72. cleanup()
  73. {
  74. rm -f $TPM_TMPFILE 2>&1
  75. }
  76. # Function: main
  77. #
  78. # Description: - Execute all tests, report results.
  79. #
  80. # Exit: - zero on success
  81. # - non-zero on failure.
  82. TFAILCNT=0 # Set TFAILCNT to 0, increment on failure.
  83. RC=0 # Return code from tests.
  84. export TCID=tpm_selftest # Test ID
  85. export TST_TOTAL=2 # Total numner of tests in this file.
  86. export TST_COUNT=0 # Initialize identifier
  87. setup || exit $RC # Exit if initializing testcases fails.
  88. test01 || TFAILCNT=$(($TFAILCNT+1))
  89. test02 || TFAILCNT=$(($TFAILCNT+1))
  90. cleanup
  91. exit $TFAILCNT